package net.p0f.samples.rhpam_fuse_integration.cdi;

import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

import javax.ejb.Startup;
import javax.enterprise.context.ApplicationScoped;
import javax.enterprise.inject.Produces;

@ApplicationScoped
@Startup
public class ConfigProducer {
	private Properties p = new Properties();

	public ConfigProducer() {
		InputStream pi = this.getClass().getResourceAsStream("/rhpam-rest-client.properties");
		try {
			this.p.load(pi);
			pi.close();
		} catch (IOException ioe) {
			// log something or whatever
		} finally {
			// ?
		}
	}

	@Produces
	@EndpointUrl
	public String getEndpointUrl() {
		return this.p.getProperty("rhpam.endpoint", "unknown");
	}

	@Produces
	@AuthUsername
	public String getAuthUsername() {
		return this.p.getProperty("rhpam.username", "admin");
	}

	@Produces
	@AuthPassword
	public String getAuthPassword() {
		return this.p.getProperty("rhpam.password", "admin");
	}
}
