package net.p0f.samples.rhpam_fuse_integration.rest_client;

import java.io.IOException;
import java.io.InputStream;

import javax.ws.rs.core.Response;

public class ManualRhpamResponse {
	private int status;
	private String statusText;
	private String responseBody;
	private String responseBodyType;

	public ManualRhpamResponse(Response r) {
		this.setStatus(r.getStatus());
		this.setStatusText(r.getStatusInfo().getReasonPhrase());
		this.setResponseBodyType(r.getEntity().getClass().getCanonicalName());

		try {
			this.setResponseBody(new String(((InputStream)r.getEntity()).readAllBytes()));
		} catch (IOException ioe) {
			this.setResponseBody("unreadable");
		} finally {
			// do something
		}
	}

	public int getStatus() {
		return status;
	}
	public void setStatus(int status) {
		this.status = status;
	}
	public String getStatusText() {
		return statusText;
	}
	public void setStatusText(String statusText) {
		this.statusText = statusText;
	}
	public String getResponseBody() {
		return responseBody;
	}
	public void setResponseBody(String responseBody) {
		this.responseBody = responseBody;
	}
	public String getResponseBodyType() {
		return responseBodyType;
	}
	public void setResponseBodyType(String responseBodyType) {
		this.responseBodyType = responseBodyType;
	}
	public String toString() {
		return "[HTTP/" + this.status + ": " + this.statusText + "]<" + this.responseBodyType + ">: " + this.responseBody;
	}
}
